<template>
  <div>
    <treePage title="耗材类别列表" @on-result-change="_refresh">
      <template slot="tree">
        <relResourceTree ref="treeModal" @on-result-change="_treeData" />
      </template>
      <template slot="cont">
        <el-row>
          <!--查询-->
          <el-col :span="24">
            <Form
              v-show="searchOpen"
              onsubmit="return false"
              :label-width="60"
              inline
            >
              <label class="label-sign" />
              <Form-item class="search-item" label="名称:">
                <el-input v-model="formObj.name" placeholder="请输入名称" clearable @keyup.enter.native="_formSearch" />
              </Form-item>
              <Form-item class="search-btn">
                <el-button type="primary" @click="_formSearch">
                  搜索
                </el-button>
              </Form-item>
            </Form>
          </el-col>
          <!--按钮-->
          <el-col :span="24">
            <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />
          </el-col>
          <!--table-->
          <el-col :span="24">
            <element-table
              ref="pageTable"
              :page-columns="pageColumns"
              :table-height="tableHeight"
              :get-page="getPage"
              :icon-msg="iconMsg"
              :opt-col-width="70"
              show-check-box
              @on-result-change="_tableResultChange"
            >
              <el-table-column
                v-for="item in pageColumns"
                :key="item.key"
                show-overflow-tooltip
                sortable
                :prop="item.key"
                :label="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
              >
                <template slot-scope="scope">
                  <a v-if="item.detail" @click.stop="_detailModal(scope.row.id)">
                    {{ scope.row[item.key] }}
                  </a>
                  <div v-else-if="item.key==='icon'">
                    <i class="iconfont" :class="scope.row[item.key]" /> {{ scope.row[item.key] }}
                  </div>
                  <div v-else-if="item.key==='type'">
                    <div v-if="scope.row[item.key]===0" class="green-color">
                      PC菜单
                    </div>
                    <div v-else-if="scope.row[item.key]===2" class="blue-color">
                      APP菜单
                    </div>
                    <div v-else class="warning-color">
                      按钮
                    </div>
                  </div>
                  <div v-else-if="item.key==='status'">
                    <div v-if="scope.row[item.key]===0" class="red-color">
                      禁用
                    </div>
                    <div v-else class="blue-color">
                      正常
                    </div>
                  </div>
                  <div v-else>
                    {{ scope.row[item.key] }}
                  </div>
                </template>
              </el-table-column>
            </element-table>
          </el-col>
        </el-row>
      </template>
    </treePage>
    <!--添加编辑-->
    <resourceEdit ref="editModal" @on-result-change="_search" />
    <!--生成采购单-->
    <LmsConsumeRelPurchase ref="consumeRelPurchaseModal" @on-result-change="_search" />
  </div>
</template>
<script>
import { consumeRelPurchase, consumeLedger } from '../../../api'
import treePage from '../../../components/base/treePage'
import relResourceTree from './tree/relConsumeCategoryTree'
import resourceEdit from './LmsConsumePurchaseEdit'
import LmsConsumeRelPurchase from './make-purchase/LmsConsumeRelPurchase'
export default {
  components: {
    treePage,
    relResourceTree,
    LmsConsumeRelPurchase,
    resourceEdit
  },
  data() {
    return {
      searchOpen: false,
      btn: [
        { type: 'success', id: '', name: '添加采购' },
        { type: 'success', id: '', name: '生成采购单' }
      ],
      iconMsg: [{ type: 'pt-edit', id: '', name: '编辑' }],
      pageColumns: [
        { title: '耗材编号', width: 150, key: 'num', fixed: 'left' },
        {
          title: '耗材名称',
          key: 'name',
          width: 200,
          detail: true,
          fixed: 'left'
        },
        { title: '耗材类别', width: 140, key: 'category' },
        { title: '最低有效期', width: 140, key: 'validDate', date: true },
        { title: '仓库位置', width: 200, key: 'storehouse' },
        { title: '规格', width: 100, key: 'spec' },
        { title: '累计出库量', width: 120, key: 'allOutStock' },
        { title: '库存量', width: 100, key: 'stock', stock: true },
        { title: '计量单位', width: 100, key: 'unit' },
        { title: '使用部门', key: 'useDepartment', width: 100 },
        {
          title: '最低库存量',
          width: 120,
          key: 'lowerStock',
          lowerStock: true
        },
        { title: '等级（纯度）', width: 130, key: 'quality' },
        { title: '保存条件', width: 140, key: 'saveCondition' },
        { title: '保管人', width: 140, key: 'saver' },
        { title: '单价', key: 'unitPrice', width: 100 },
        { title: '制造厂商', width: 200, key: 'manufacturer' },
        { title: '密度', width: 100, key: 'thickness' },
        { title: '精确度等级', width: 150, key: 'unsure' },
        { title: '标准值', width: 100, key: 'standard' },
        { title: '转化率', width: 100, key: 'exchange' },
        { title: '转化库存量', width: 150, key: 'exstock' },
        { title: '转化计量单位', width: 160, key: 'exunit' },
        { title: '备注', width: 140, key: 'remark' }
      ],
      formObj: {
        id: '',
        name: '',
        status: ''
      },
      getPage: {},
      selectIds: [],
      statusList: [
        {
          value: '0',
          name: '禁用'
        },
        {
          value: '1',
          name: '正常'
        }
      ],
      treeObj: {}
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._search()
  },
  methods: {
    // 刷新
    _refresh() {
      this.formObj.id = ''
      this.treeObj = {}
      this._formSearch()
    },
    _search() {
      this._formSearch()
      this.$refs.treeModal._open()
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await consumeLedger.pageVO(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加采购':
          this._addToPurchase()
          break
        case '生成采购单':
          this._makeToPurchaseOrder()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data)
          break
      }
    },
    _editModal: async function(data) {
      const result = await consumeLedger.getVOById(data.id)
      this.$refs.editModal._open('', result)
    },
    // 详情
    _detailModal(id) {
      this.$refs.detailModal._open(id)
    },
    _treeData(data) {
      this.formObj.id = data.id
      this.treeObj = data
      this._formSearch()
    },
    _addToPurchase() {
      const ids = this.selectIds
      if (ids === undefined || ids.length === 0) {
        this.$Message.warning('请选中要购买的耗材！')
      } else {
        this._addPurIds(ids)
      }
    },
    _makeToPurchaseOrder() {
      this.$refs.consumeRelPurchaseModal._open()
    },
    _addPurIds: async function(ids) {
      const result = await consumeRelPurchase.addConsumeRelPurchase(ids)
      if (result) {
        this.$Message.success('成功加入采购单！')
        this._page()
        this.selectIds = []
      }
    }
  }
}
</script>
